library(ggplot2)

set.seed(123)
n <- 100
m <- 1000
F_vals <- numeric(m)

for (i in 1:m) {
  x <- rnorm(n)
  y <- rnorm(n)
  fit <- lm(y ~ x)
  F_vals[i] <- summary(fit)$fstatistic[1]
}

# Fvʂ̃qXgO
hist_data <- data.frame(F_vals)
ggplot(hist_data, aes(x=F_vals)) +
  geom_histogram(aes(y=..density..), bins=30, colour="black", fill="white") +
  stat_function(fun=df, args=list(df1=df1, df2=df2), colour="blue") +
  ylim(0, 1) +  # y̏1ɐݒ
  labs(title="W0̃fɂFvʂ̕pxzFz̏dˍ킹",
       x="F value",
       y="Density")
