# KvȃCũ[h
library(ggplot2)

# V~[Ṽp[^
n <- 100       # TvTCY
num_sims <- 5000  # V~[V
t_values <- numeric(num_sims)  # tli[xNg

# V~[Vs
for (i in 1:num_sims) {
  x <- rnorm(n)  # Kzɏ]ϐ
  y <- rnorm(n)  # ϐƂ͓ƗȐKzɏ]ϐ
  
  # fUCs
  X <- cbind(1, x)
  
  # ŏ搄
  beta_hat <- solve(t(X) %*% X) %*% t(X) %*% y
  
  # cǎvZ
  y_hat <- X %*% beta_hat
  residuals <- y - y_hat
  RSS <- sum(residuals^2)
  
  # cU̐
  sigma_squared <- RSS / (n - ncol(X))
  
  # W덷̌vZ
  cov_beta <- sigma_squared * solve(t(X) %*% X)
  SE_beta <- sqrt(diag(cov_beta))
  
  # tľvZiAW2ԖځA܂x̌Wj
  t_values[i] <- beta_hat[2] / SE_beta[2]
}

# pl0.05ƂȂtvʂ臒lvZ
df <- n - (ncol(X)-1) - 1
t_critical <- qt(0.025, df, lower.tail = FALSE)  # ̂

# tl̕z̃vbgpf[^t[쐬
df_t_values <- data.frame(t_values, density = dt(t_values, df))
df_t_values$significant <- with(df_t_values, ifelse(t_values < -t_critical | t_values > t_critical, density, 0))

# tl̕z̃vbg
ggplot(df_t_values, aes(x = t_values)) +
  geom_histogram(aes(y = ..density..), binwidth = 0.2, color = "black", fill = "white") +
  stat_function(fun = dt, args = list(df = df), color = "red", size = 1) +
  geom_area(aes(y = significant), fill = "red", alpha = 0.5) +
  labs(title = "Distribution of t-values with Significance Threshold", x = "t Value", y = "Density")
