# KvȃpbP[W[h
library(ggplot2)

# p[^̐ݒ
n <- 100  # TvTCY
p <- 1    # ϐ̐iؕЂ܂܂Ȃj
num_simulations <- 1000  # V~[V̉
true_variance <- 2  # ^̕U

# sΕUi[xNg
unbiased_variances <- numeric(num_simulations)

# V~[V
set.seed(123)
for (i in 1:num_simulations) {
  x <- rnorm(n)  # ϐ
  y <- 1 + 2 * x + rnorm(n, sd = sqrt(true_variance))  # ϐ
  model <- lm(y ~ x)  # `Af̃tBbg
  residuals <- residuals(model)
  rss <- sum(residuals^2)  # ca
  unbiased_variances[i] <- rss / (n - p - 1)  # sΕU
}

# sΕU̕z̃f[^t[
variances_df <- data.frame(UnbiasedVariance = unbiased_variances)

# qXgOƃJC敪zPDF`
ggplot(variances_df, aes(x = UnbiasedVariance)) +
  geom_histogram(aes(y = ..density..), binwidth = 0.1, fill = "red", alpha = 0.5) +
  stat_function(fun = function(x) dchisq(x * (n - p - 1) / true_variance, df = n - p - 1) * (n - p - 1) / true_variance, 
                color = "black", size = 1) +
  labs(title = "Distribution of Unbiased Variance of Residuals",
       x = "Unbiased Variance",
       y = "Density") +
  theme_minimal()
