# p[^ݒ
mu <- 0               # ꕽ
sigma <- 2            # W΍
n <- 10               # TvTCY
simulations <- 10000  # V~[V

# V~[V
sample_variances <- numeric(simulations)    # W{Ůi[p
unbiased_variances <- numeric(simulations)  # sΕŮi[p

for (i in 1:simulations) {
  sample <- rnorm(n, mean = mu, sd = sigma)
  sample_mean <- mean(sample)
  
  # W{ǓvZ
  sample_variances[i] <- sum((sample - sample_mean)^2) / n
  
  # sΕǓvZ
  unbiased_variances[i] <- sum((sample - sample_mean)^2) / (n - 1)
}

# W{UƕsΕU̕ϒľvZ
average_sample_variance <- mean(sample_variances)
average_unbiased_variance <- mean(unbiased_variances)

# ʂ̏o
list(average_sample_variance = average_sample_variance, average_unbiased_variance = average_unbiased_variance)
