# KvȃpbP[Wǂݍ
if (!require("readr")) install.packages("readr", dependencies=TRUE)
if (!require("plotly")) install.packages("plotly", dependencies=TRUE)
library(readr)
library(plotly)

# CSVt@C̓ǂݍ
data <- read_csv("y_x1_x2.csv")

# f[^̍\mF
print(head(data))
str(data)

# fUCs쐬
X <- as.matrix(cbind(1, data$x1, data$x2))

# ]ϐxNg
y <- as.matrix(data$y)

# ŏ@pČWxNgbetavZ
beta <- solve(t(X) %*% X) %*% t(X) %*% y

# WxNg̕\
print(beta)

# f[^3DUz}ƉAʂvbg
plot_ly() %>%
  add_trace(data = data, x = ~x1, y = ~x2, z = ~y, type = 'scatter3d', mode = 'markers') %>%
  add_trace(
    data = expand.grid(x1 = seq(min(data$x1), max(data$x1), length.out = 30),
                       x2 = seq(min(data$x2), max(data$x2), length.out = 30)),
    x = ~x1,
    y = ~x2,
    z = ~beta[1] + beta[2]*x1 + beta[3]*x2,
    type = 'mesh3d', opacity = 0.5
  ) %>%
  layout(scene = list(
    xaxis = list(title = "x1"),
    yaxis = list(title = "x2"),
    zaxis = list(title = "y")
  ))